(function($, owner) {
	owner.appVersionId = 12;
	owner.appVersion = '3.4.1';
	owner.loginInfoKey = '$LoginInfoKey';

	/**
	 * 获取当前登录信息
	 **/
	owner.getLoginInfo = function() {
		var stateText = localStorage.getItem(owner.loginInfoKey) || '"{}"';
		return JSON.parse(stateText);
	};
	
	/**
	 * 获取当前登录的userId
	 */
	owner.getUserId = function() {
		return owner.getLoginInfo().userId || '';
	};
	
	/**
	 * 获取当前登录的token
	 */
	owner.getToken = function() {
		return owner.getLoginInfo().token || '';
	};
	
	/**
	 * 设置当前登录信息
	 **/
	owner.setLoginInfo = function(info) {
		info = info || {};
		localStorage.setItem(owner.loginInfoKey, JSON.stringify(info));
	};
	
	/**
	 * 清除登录信息
	 */
	owner.clearloginInfo = function() {
		owner.setLoginInfo(false);
	};
	
	/**
	 * 判断是否已登录
	 */
	owner.hasLogin = function() {
		var loginInfo = owner.getLoginInfo();
		if (loginInfo.userId && loginInfo.token) {
			return true;
		}
		return false;
	}
}(mui, window.app = {}));