(function($, owner) {
	/**
	 * 初始化工单数量
	 * @param {Object} oid
	 * @param {Object} callback
	 */
	owner.initCommentList = function(callback){
		
		if(!app.hasLogin()){
			return;
		}
		
		callback = callback || $.noop;
		
		var data = {
			userid : app.getUserId()+"",
			token:app.getToken()
		};
		
		var requestCallback = function(success,returnData){
            if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.data);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		}
		commonProtocol.postRequest("/commentNum",data,requestCallback);
	}
	/**
	 * 评论列表
	 * @param {Object} callback
	 */
	owner.gainCommentList = function(pageNo,callback){
		
		if(!app.hasLogin()){
			return;
		}
		
		callback = callback || $.noop;
		
		var data = {
			userid : app.getUserId()+"",
			token:app.getToken(),
			pageNo:pageNo
		};
		
		var requestCallback = function(success,returnData){
            if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.data);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		}
		commonProtocol.postRequest("/commentList",data,requestCallback);
	}
}(mui, window.commentChat = {}));