(function($, owner) {
	owner.serverDomain = 'http://superepairman.com';
	owner.server = owner.serverDomain + '/app.json'; 
	owner.chatServer = owner.serverDomain + '/interface';
	
	owner.protocolError = function(isTokenInvalid, msg) {
		plus.nativeUI.closeWaiting();
		$.fire(plus.webview.getWebviewById(plus.runtime.appid), 'ProtocolError', {isTokeninvalid: isTokenInvalid, msg: msg});
	};
	/**
	 * 向服务器请求数据
	 * @param {Object} url		请求地址，不包括domain
	 * @param {Object} data		要发送的数据
	 * @param {Object} callback	回调函数，参数：success: ture|false，是否成功，
	 * 							data: object|{errType: xxx, errMsg: xxx}，数据或错误信息
	 */
	owner.postRequest = function(urlStr, data, callback, isChat) {
		var isLogout = !isChat && (-1 != urlStr.indexOf('/logout') || -1 != urlStr.indexOf('/updateClientId'));
		if (plus.networkinfo.CONNECTION_NONE == plus.networkinfo.getCurrentType()) {
			!isLogout && owner.protocolError(false, '您的手机没有连接到网络，请先打开网络');
			callback(false, {errType: 'null', errMsg: '没有打开网络'});
			return;
		}
		urlStr = urlStr ? urlStr : '/';
		if ('/' != urlStr.charAt(0)) {
			urlStr = '/' + urlStr;  
		}
		callback = callback || $.noop;
		data = data || {}; 
		var sCallback = function(resultData, testStatus, xhr) {
			if (resultData) {
				// TODO remove later
//				console.log('resultData: ' + (('object' == typeof resultData) ? JSON.stringify(resultData) : resultData));
				////////////////////
				
				var obj = resultData;
				if ('object' != typeof obj) {
					try {
						obj = JSON.parse(resultData)
					} catch(err) {
						!isLogout && owner.protocolError(false, '数据格式错误，无法解析数据');
						return callback(false, {errType: 'null', errMsg: '数据格式错误，无法解析数据'});
					}
				}
				if (2 == obj.code || '登陆Token失效' == obj.msg) {
					!isLogout && owner.protocolError(true, '登陆Token失效');
					return callback(false, {errType: 'null', errMsg: obj.msg});
				}
				return callback(true, obj);
			}
			!isLogout && owner.protocolError(false, '无数据返回，可能是网络断开了');
			return callback(false, {errType: 'null', errMsg: '无数据返回，可能是网络断开了'});
		}
		var eCallback = function(xhr, type, errThrown) {
			var errMsg = '未知错误';
			if ('abort' == type) {
				errMsg = '连接不到服务器，请确定已连接到网络';
			} else if ('timeout' == type) {
				errMsg = '网络不稳定，连接超时';
			} else if ('parsererror' == type) {
				errMsg = '数据格式错误，无法解析数据';
			}
			!isLogout && owner.protocolError(false, errMsg);
			return callback(false, {errType: type || 'null', errMsg: errMsg});
		}
		if (app) {
			if (!data.userId || !data.token) {
				var loginInfo = app.getLoginInfo();
				if (loginInfo && loginInfo.userId && loginInfo.token) {
					data.userId = loginInfo.userId;
					data.token = loginInfo.token;
				}
			}
			data.appV = app.appVersion;
		}
		if ($.os.ios) {
			data.pt = 'i';
		} else if ($.os.android) {
			data.pt = 'a';
		} else {
			data.pt = "o"
		}
		data.osV = plus.os.version;
		
		// TODO, remove this later
		//console.log('\nbefore request, url: ' + (isChat ? owner.chatServer : owner.server) + urlStr + ', \n\t\tdata: ' + JSON.stringify(data));
		///////////////////////////
		
		$.ajax((isChat ? owner.chatServer : owner.server) + urlStr, {
			type: 'POST',
			data: isChat ? data : ('data=' + JSON.stringify(data)),
			dataType: isChat ? 'json' : 'text',
			contentType: 'application/x-www-form-urlencoded; charset=utf-8',
			timeout: 30000,
			success: sCallback,
			error: eCallback
		});
	};
}(mui, window.commonProtocol = {}));
