(function($, owner) {
	/**
	 * 初始化工单详情
	 * @param {Object} oid
	 * @param {Object} callback
	 */
	owner.initOrderDetail = function(oid,callback){
		
		if(!app.hasLogin()){
			return;
		}
		
		callback = callback || $.noop;
		
		var data = {
			userid : app.getUserId()+"",
			token:app.getToken(),
			oid:oid+""
		};
		
		var requestCallback = function(success,returnData){
            if(success == "false") return;
            
			if(returnData.code == 0){
				callback(returnData.data);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		}
		commonProtocol.postRequest("/gainEngineerOrderDetail",data,requestCallback);
	}
	/**
	 *  查询快递
	 * @param {Object} kdNum
	 * @param {Object} kdCompany
	 * @param {Object} callback
	 */
	owner.checkKD = function(kdNum,kdCompany,callback){
		
		if(!app.hasLogin()){
			return;
		}
		
		callback = callback || $.noop;
		
		var data = {
			kdNum:kdNum,
			kdCompany:kdCompany
		};
		
		var requestCallback = function(success,returnData){
            if(success == "false") return;
            
			if(returnData.code == 0){
				callback(returnData.data);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		}
		commonProtocol.postRequest("/kdCheck",data,requestCallback);
	}
	
	/**
	 * 获取工单预约历史
	 * @param {Object} oid
	 */
	owner.gainBookingHistory = function(oid,callback){
		
		
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		 
		var data = {
			oid:oid
		}
		
		commonProtocol.postRequest("/bookingHistory",data,function(success,returnData){
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.data);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
		
	}
	
	owner.gainEngineerOrderComponent = function(oid,callback){
		
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		var data = {
			oid:oid
		}
		commonProtocol.postRequest("/gainEngineerOrderComponent",data,function(success,returnData){
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.data);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 接单操作
	 * @param {Object} oid
	 * @param {Object} callback
	 */
	owner.acceptOrder = function(oid,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid
		}
		
		commonProtocol.postRequest("/engineer/accept",data,function(success,returnData){
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
			
		});
		
	}
	/**
	 * 拒单操作
	 * @param {Object} oid
	 * @param {Object} remark
	 * @param {Object} callback
	 */
	owner.refuseOrder = function(oid,remark,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid,
			remark:remark
		}
		
		commonProtocol.postRequest("/engineer/refuse",data,function(success,returnData){
			
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 预约时间
	 * @param {Object} oid
	 * @param {Object} time
	 * @param {Object} remark
	 * @param {Object} callback
	 */
	owner.bookingOrder = function(oid,time,remark,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid,
			remark:remark,
			time:time
		}
		
		commonProtocol.postRequest("/engineer/book",data,function(success,returnData){
			console.log(JSON.stringify(returnData)); 
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
		
	}
	
	/**
	 * 预约时间
	 * @param {Object} oid
	 * @param {Object} time
	 * @param {Object} remark
	 * @param {Object} callback
	 */
	owner.againbookingOrder = function(oid,time,remark,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid,
			remark:remark,
			time:time
		}
		
		commonProtocol.postRequest("/engineer/againBookTime",data,function(success,returnData){
			
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 申请配件
	 * @param {Object} oid
	 * @param {Object} remark
	 * @param {Object} addrId
	 * @param {Object} imgs
	 * @param {Object} callback
	 */
	owner.componentOrder = function(oid,remark,addrId,imgs,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid,
			remark:remark,
			addrId:addrId,
			imgs:imgs
		}
		 
		commonProtocol.postRequest("/engineer/applycomponent",data,function(success,returnData){
			
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 寄回配件
	 * @param {Object} oid
	 * @param {Object} trackNo
	 * @param {Object} trackType
	 * @param {Object} fee
	 * @param {Object} payType
	 */
	owner.backComponentOrder = function(oid,trackNo,trackType,fee,payType,waiting,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid+"",
			trackNo:trackNo,
			trackType:trackType,
			fee:fee,
			payType:payType
		}
		
		commonProtocol.postRequest("/engineer/backcomponent",data,function(success,returnData){
			waiting.close();
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 完成工单
	 * @param {Object} oid
	 * @param {Object} type
	 * @param {Object} remark
	 */
	owner.finishOrder = function(oid,type,remark,code,ids,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		var data = {
			id:oid,
			type:type,
			remark:remark,
			code:code,
			ids:ids
		}
		
		commonProtocol.postRequest("/engineer/finish",data,function(success,returnData){
			
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	/**
	 * 撤单
	 * @param {Object} id
	 * @param {Object} reason
	 */
	owner.revokeOrder = function(id,reason,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		var data = {
			id:id,
			reason:reason
		}
		commonProtocol.postRequest("/engineer/revoke",data,function(success,returnData){
			
			if(success == "false") return;
			callback(returnData);
		});
	}
	/**
	 * 添加地址接口
	 * @param {Object} addr
	 */
	owner.addEngineerAddress = function(addr,callback){
		
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		var data = {
			addr:addr
		}
		commonProtocol.postRequest("/engineer/addr/add",data,function(success,returnData){
			
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 获取工程师地址
	 */
	owner.getEngineerAddress = function(callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		 
		var data = {}
		
		commonProtocol.postRequest("/engineer/addr/get",data,function(success,returnData){
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.data);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 检查是否需要配件
	 * @param {Object} oid
	 * @param {Object} states
	 * @param {Object} callback
	 */
	owner.isCheckOrderState = function(oid,states,callback){
		
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid+"",
			state:states
		}
		
		commonProtocol.postRequest("/ischeckOrder",data,function(success,returnData){
			if(success == "false") return;
			callback(returnData);
		});
	}
	
	/**
	 * 不同意终止工单
	 * @param {Object} oid
	 * @param {Object} states
	 * @param {Object} callback
	 */
	owner.disAgreeEndOrder = function(oid,reason,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid+"",
			reason:reason
		}
		commonProtocol.postRequest("/order/end/disagree",data,function(success,returnData){
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	/**
	 * 同意终止工单
	 * @param {Object} oid
	 * @param {Object} states
	 * @param {Object} callback
	 */
	owner.agreeEndOrder = function(oid,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var data = {
			id:oid+""
		}
		commonProtocol.postRequest("/order/end/agree",data,function(success,returnData){
			if(success == "false") return;
			if(returnData.code == 0){
				callback(returnData.code);
			}else{
				plus.nativeUI.toast(returnData.msg);
			}
		});
	}
	
	
	/***
	 * 填写上门码
	 * @param {Object} oid       工单Id
	 * @param {Object} homeCode  上门码
	 * @param {Object} callback  回调
	 */
	owner.installFillCode = function(oid,homeCode,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var lat = "";
		var lng = "";
		var address = "";
		
		plus.geolocation.getCurrentPosition( function(position){
			var codns = position.coords;//获取地理坐标信息；
			lat = codns.latitude;//获取到当前位置的纬度；
			lng = codns.longitude;//获取到当前位置的经度
			address = position.addresses;
			
			setTimeout(function(){
				var data = {
					id:oid+"",
					homeCode:homeCode,
					lat:lat+'',
					lng:lng+'',
					address:address
				}
				commonProtocol.postRequest("/engineer/fillCode",data,function(success,returnData){
					console.log("returnData:"+JSON.stringify(returnData));//输出json格式
					if(success == "false") return;
					console.log(JSON.stringify(returnData));//输出json格式
					if(returnData.code == 0){
						callback(returnData.code);
					}else{
						plus.nativeUI.toast(returnData.msg);
						callback(returnData.code);
					}
			    });
			},500);
			
		}, function ( e ) {
		    $.toast("地址获取不到，请重试");
	    },{provider:'baidu'});
	}
	
	/**
	 * 填写完成码
	 * @param {Object} oid       工单ID
	 * @param {Object} code      工单码
	 * @param {Object} callback  回调函数
	 */
	owner.installFinishCode = function(oid,code,callback){
		if(!app.hasLogin()) return;
		callback = callback || $.noop;
		
		var lat = "";
		var lng = "";
		var address = "";
		
		plus.geolocation.getCurrentPosition( function(position){
			var codns = position.coords;//获取地理坐标信息；
			lat = codns.latitude;//获取到当前位置的纬度；
			lng = codns.longitude;//获取到当前位置的经度
			address = position.addresses;
			
			setTimeout(function(){
				var data = {
					id:oid+"",
					code:code,
					lat:lat+'',
					lng:lng+'',
					address:address
				}
				commonProtocol.postRequest("/engineer/install/finish",data,function(success,returnData){
					if(success == "false") return;
					if(returnData.code == 0){
						callback(returnData.code);
					}else{
						plus.nativeUI.toast(returnData.msg);
						callback(returnData.code);
					}
				});
			},500);
			
		}, function ( e ) {
		    console.log( "获取位置信息失败："+e.message );
		    $.toast("地址获取不到，请重试");
	    },{provider:'baidu'});

	}
	
	
}(mui, window.engineerOrderDetail = {}));